/**
 * 
 */
package de.mcs.tools.sps.emulator;

import java.util.ArrayList;
import java.util.List;

/**
 * @author w.klaas
 *
 */
public class SPSCommandImpl implements SPSCommand {

  String name;
  String mnemonic;
  byte cmdByte;
  List<SPSCommandData> datas = new ArrayList<>();

  /**
   * 
   */
  public SPSCommandImpl() {
  }

  @Override
  public String getName() {
    return name;
  }

  @Override
  public String getMnemonic() {
    return mnemonic;
  }

  @Override
  public byte getCommandByte() {
    return cmdByte;
  }

  @Override
  public List<SPSCommandData> getCommandDatas() {
    return datas;
  }

  /**
   * @param cmdByte
   *          the cmdByte to set
   */
  public SPSCommandImpl setCommandByte(byte cmdByte) {
    this.cmdByte = cmdByte;
    return this;
  }

  /**
   * @param name
   *          the name to set
   */
  public SPSCommandImpl setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * @param mnemonic
   *          the mnemonic to set
   * @return
   */
  public SPSCommandImpl setMnemonic(String mnemonic) {
    this.mnemonic = mnemonic;
    return this;
  }

  @Override
  public String toString() {
    return String.format("%s (%s): %.2X", getMnemonic(), getName(), getCommandByte());
  }
}
